/***************************************************************************
                          client.c  -  description
                             -------------------
    begin                : 2002 03 06
    copyright            : (C) 2002 by Murat Selim Ozturk
    email                : sozturk@spartacus.com.tr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <string.h>
#include "parsecfg.h"

#define PORT        0x1234
#define DIRSIZE     8192
#define PAR_FILENAME "/etc/tmon_unix_client.cfg"

main(argc, argv)
int argc; char **argv;
{
  char par_filename[200];
  char *myipaddress, *shutdown_cmd, *shutdown_cancel, *shutdown_immediate, *hostname;
	char    dir[DIRSIZE];
  char  message[100];
  char actionstr[9],secondstr[5],log_message[DIRSIZE];
	int	sd, seconds, sleeptime, port_number, debug;
  char action;

	struct sockaddr_in sin;
	struct sockaddr_in pin;
	struct hostent *hp;

  strcpy(par_filename, PAR_FILENAME);

  if (argc>1)
      { strcpy(par_filename,argv[1]);
  } else {
    perror("parameter file");
  }

   if (fetchVarFromCfgFile(par_filename, "MY_IP_ADDRESS", &myipaddress, CFG_STRING, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("MY_IP_ADDRESS Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "SERVER_ADDRESS", &hostname, CFG_STRING, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("SERVER_ADDRESS Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "SHUTDOWN_CMD", &shutdown_cmd, CFG_STRING, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("SHUTDOWN_CMD Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "SHUTDOWN_CANCEL", &shutdown_cancel, CFG_STRING, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("SHUTDOWN_CANCEL Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "SHUTDOWN_IMMEDIATE", &shutdown_immediate, CFG_STRING, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("SHUTDOWN_IMMEDIATE Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "SERVER_PORT", &port_number, CFG_LONG, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("SERVER_PORT Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "SLEEP_SECONDS", &sleeptime, CFG_LONG, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("SLEEP_SECONDS Error");
 	}
   if (fetchVarFromCfgFile(par_filename, "DEBUG", &debug, CFG_LONG, CFG_SIMPLE, (int) NULL, NULL)==-1) {
 		perror("DEBUG Error");
 	}

  /* prepare our message to the server */
  sprintf(message,"H:CL10>IP:%s>C:DRY1",myipaddress);
	/* go find out about the desired host machine */
	if ((hp = gethostbyname(hostname)) == 0) {
		perror("gethostbyname");
		exit(1);
	}

  while(1) {
	/* fill in the socket structure with host information */
  	memset(&pin, 0, sizeof(pin));
  	pin.sin_family = AF_INET;
  	pin.sin_addr.s_addr = ((struct in_addr *)(hp->h_addr))->s_addr;
  	pin.sin_port = htons(port_number);

  	/* grab an Internet domain socket */
  	if ((sd = socket(AF_INET, SOCK_STREAM, 0)) == -1) {
  		perror("socket");
  	}

  	/* connect to PORT on HOST */
  	if (connect(sd,(struct sockaddr *)  &pin, sizeof(pin)) == -1) {
  		perror("connect");
  	} else {

   	/* send a message to the server PORT on machine HOST */
   	if (send(sd, message, strlen(message), 0) == -1) {
   		perror("send");
   	} else {

      /* wait for a message to come back from the server */
      if (recv(sd, dir, DIRSIZE, 0) == -1) {
              perror("recv");
      } else {

   		if (dir[0]=='#' ) {

        /* spew-out the results and bail out of here! */
        strncpy(actionstr, dir+1,8);
        strncpy(secondstr, dir+9,4);
        strncpy(log_message, dir+16, strlen(dir+16)-2);

        if (!(seconds = strtol(secondstr,(char **)NULL,10))) {
          seconds = 0;
        }
        action = ups_action(actionstr);
        printf("%s:%d:%s:%d:%s\n", dir,action,secondstr,seconds,log_message );

        ups_perform(action, seconds, log_message, shutdown_cmd, shutdown_cancel, shutdown_immediate);
       }
			}
    }
   	close(sd);
    }
    sleep(sleeptime);
  }
}


